function varargout = Eta_Scaling(varargin)
% ETA_SCALING MATLAB code for Eta_Scaling.fig
%      ETA_SCALING, by itself, creates a new ETA_SCALING or raises the existing
%      singleton*.
%
%      H = ETA_SCALING returns the handle to a new ETA_SCALING or the handle to
%      the existing singleton*.
%
%      ETA_SCALING('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ETA_SCALING.M with the given input arguments.
%
%      ETA_SCALING('Property','Value',...) creates a new ETA_SCALING or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Eta_Scaling_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Eta_Scaling_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Eta_Scaling

% Last Modified by GUIDE v2.5 01-Jul-2015 23:58:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Eta_Scaling_OpeningFcn, ...
                   'gui_OutputFcn',  @Eta_Scaling_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Eta_Scaling is made visible.
function Eta_Scaling_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Eta_Scaling (see VARARGIN)

% Choose default command line output for Eta_Scaling
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Eta_Scaling wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Eta_Scaling_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function etaPlot_ring(handles)
eta_1=str2double(get(handles.edit_eta1, 'string'));
P_out_1=str2double(get(handles.edit_P1, 'string'));
l_1=str2double(get(handles.edit_l1, 'string'));
D_ag_1=str2double(get(handles.edit_D1, 'string'));
l_2=str2double(get(handles.edit_l2, 'string'));
D_ag_2=str2double(get(handles.edit_D2, 'string'));
eta_2=str2double(get(handles.edit_eta2, 'string'));
[eta_2_PS,P_loss_tot_2,l,D_ag]=lossesPS_ring(eta_1,P_out_1,l_1,D_ag_1);
axes(handles.axes_eta)
surf(D_ag,l,eta_2_PS)
hold on
plot3(D_ag_1,l_1,eta_1,'r*')
hold off
hold on
plot3(D_ag_2,l_2,eta_2,'g*')
hold off
xlabel('Air Gap Diameter, D_{ag} [m]')
ylabel('Active Length, l [m]')
zlabel('{\eta}','fontsize',16)


function scale_losses(handles)

l_1=str2double(get(handles.edit_l1, 'string'));
D_ag_1=str2double(get(handles.edit_D1, 'string'));
l_2=str2double(get(handles.edit_l2, 'string'));
D_ag_2=str2double(get(handles.edit_D2, 'string'));
eta_1=str2double(get(handles.edit_eta1, 'string'));
P_out_1=str2double(get(handles.edit_P1, 'string'));
V_r_1=pi/4*D_ag_1^2*l_1;
V_r_2=pi/4*D_ag_2^2*l_2;
A_ag_2=pi*D_ag_2*l_2;

%Get loss_ring_1
[P_loss_tot_1,P_loss_ring_1]=loss_ring(eta_1,P_out_1,l_1,D_ag_1);
%Scale loss
P_loss_tot_2=P_loss_ring_1*A_ag_2;

%Calculate P_out and efficiency
P_out_2=V_r_2/V_r_1*P_out_1;
eta_2=P_out_2/(P_out_2+P_loss_tot_2);

set(handles.edit_loss_tot_2,'string',num2str(P_loss_tot_2,3))
set(handles.edit_eta2,'string',num2str(eta_2,3))
set(handles.edit_P2,'string',num2str(P_out_2,3))
set(handles.edit_V2,'string',num2str(V_r_2,3))





function edit_eta1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_eta1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_eta1 as text
%        str2double(get(hObject,'String')) returns contents of edit_eta1 as a double


% --- Executes during object creation, after setting all properties.
function edit_eta1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_eta1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_P1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_P1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_P1 as text
%        str2double(get(hObject,'String')) returns contents of edit_P1 as a double


% --- Executes during object creation, after setting all properties.
function edit_P1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_P1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_l1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_l1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_l1 as text
%        str2double(get(hObject,'String')) returns contents of edit_l1 as a double


% --- Executes during object creation, after setting all properties.
function edit_l1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_l1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_D1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_D1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_D1 as text
%        str2double(get(hObject,'String')) returns contents of edit_D1 as a double


% --- Executes during object creation, after setting all properties.
function edit_D1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_D1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_V1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_V1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_V1 as text
%        str2double(get(hObject,'String')) returns contents of edit_V1 as a double


% --- Executes during object creation, after setting all properties.
function edit_V1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_V1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_1 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_tot_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_tot_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_tot_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_tot_1 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_tot_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_tot_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_add_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_add_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_add_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_add_1 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_add_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_add_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_calc_V.
function push_calc_V_Callback(hObject, eventdata, handles)
% hObject    handle to push_calc_V (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
l_1=str2double(get(handles.edit_l1,'string'));
D_1=str2double(get(handles.edit_D1,'string'));
V1=pi/4*l_1*D_1^2;
set(handles.edit_V1,'string',num2str(V1))


% --- Executes on button press in push_plot_V.
function push_plot_V_Callback(hObject, eventdata, handles)
% hObject    handle to push_plot_V (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
etaPlotV(handles)


% --- Executes on key press with focus on edit_l1 and none of its controls.
function edit_l1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_l1 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in push_calc_loss.
function push_calc_loss_Callback(hObject, eventdata, handles)
% hObject    handle to push_calc_loss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
P_out_1=str2double(get(handles.edit_P1,'string'));
eta_1=str2double(get(handles.edit_eta1,'string'));
D_ag_1=str2double(get(handles.edit_D1,'string'));
l_1=str2double(get(handles.edit_l1,'string'));

[P_loss_tot_1,P_loss_ring_1]=loss_ring(eta_1,P_out_1,l_1,D_ag_1);
set(handles.edit_loss_tot_1,'string',num2str(P_loss_tot_1,3))




function edit_V2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_V2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_V2 as text
%        str2double(get(hObject,'String')) returns contents of edit_V2 as a double


% --- Executes during object creation, after setting all properties.
function edit_V2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_V2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_2 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_tot_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_tot_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_tot_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_tot_2 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_tot_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_tot_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_loss_add_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_loss_add_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_loss_add_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_loss_add_2 as a double


% --- Executes during object creation, after setting all properties.
function edit_loss_add_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_loss_add_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_scale_loss.
function push_scale_loss_Callback(hObject, eventdata, handles)
% hObject    handle to push_scale_loss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
scale_losses(handles)



function edit_P_diss_Callback(hObject, eventdata, handles)
% hObject    handle to edit_P_diss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_P_diss as text
%        str2double(get(hObject,'String')) returns contents of edit_P_diss as a double


% --- Executes during object creation, after setting all properties.
function edit_P_diss_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_P_diss (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_plot_eta_ring.
function push_plot_eta_ring_Callback(hObject, eventdata, handles)
% hObject    handle to push_plot_eta_ring (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
etaPlot_ring(handles)



function edit_P2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_P2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_P2 as text
%        str2double(get(hObject,'String')) returns contents of edit_P2 as a double


% --- Executes during object creation, after setting all properties.
function edit_P2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_P2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_eta2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_eta2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_eta2 as text
%        str2double(get(hObject,'String')) returns contents of edit_eta2 as a double


% --- Executes during object creation, after setting all properties.
function edit_eta2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_eta2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_l2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_l2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_l2 as text
%        str2double(get(hObject,'String')) returns contents of edit_l2 as a double


% --- Executes during object creation, after setting all properties.
function edit_l2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_l2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_D2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_D2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_D2 as text
%        str2double(get(hObject,'String')) returns contents of edit_D2 as a double


% --- Executes during object creation, after setting all properties.
function edit_D2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_D2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_clear.
function push_clear_Callback(hObject, eventdata, handles)
% hObject    handle to push_clear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cla(handles.axes_eta)
