function varargout = Generator_Scaling(varargin)
% GENERATOR_SCALING MATLAB code for Generator_Scaling.fig
%      GENERATOR_SCALING, by itself, creates a new GENERATOR_SCALING or
%      raises the existing
%      singleton*.
%
%      H = GENERATOR_SCALING returns the handle to a new
%      GENERATOR_SCALING or the handle to
%      the existing singleton*.
%
%      GENERATOR_SCALING('CALLBACK',hObject,eventData,handles,...)
%      calls the local
%      function named CALLBACK in GENERATOR_SCALING.M with the given input
%      arguments.
%
%      GENERATOR_SCALING('Property','Value',...) creates a new
%      GENERATOR_SCALING or raises the
%      existing singleton*.  Starting from the left, property value pairs
%      are applied to the GUI before Generator_Scaling_OpeningFcn gets
%      called. An unrecognized property name or invalid value makes
%      property application stop.  All inputs are passed to
%      Generator_Scaling_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Generator_Scaling

% Last Modified by GUIDE v2.5 24-Jun-2015 17:18:26


% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Generator_Scaling_OpeningFcn, ...
                   'gui_OutputFcn',  @Generator_Scaling_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Generator_Scaling is made visible.
function Generator_Scaling_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Generator_Scaling (see VARARGIN)

global radio BDet ADet SDet Smry k_ad k_fc k_act k_cy k_D_o k_Cu k_Feys k_Feyr k_PM k_l k_D k_V n
k_ad=0.2;                       %ratio of additional losses to Cu,Fe-losses
                                %source:Grauers
k_fc=1/6;                       %ratio of Fe to Cu losses.
                                %source:Krovel.
%(used by mass_division.m)                                
k_act=0.45;                     %ratio m_act/m_tot
                                %source:Polinder - Scaling laws DDG
k_cy=0.5;                       %ratio m_cy/m_tot
                                %source:Polinder - Scaling laws DDG
k_D_o=1.12;                     %ratio of D_external/D_ag

%Active Mass distribution, fraction of m_em (used by scaling.m)
%Source: Blaaster Wind Technologies
k_Cu = 0.295; %Copper
k_Feys = 0.385; %stator yoke and teeth
k_Feyr = 0.260; %Rotor yoke
k_PM = 0.06; %Permanent magnets


%Ranges for plots (used by ranges.m)                                
k_l=0.5;                        %allowed change of length
k_D=0.2;                        %allowed change of Diameter

n=20;                           %number of data points for plots

radio = [handles.radio_ref1, handles.radio_ref2, handles.radio_ref3];

%import details for predefined reference generators
[BDet, ADet, SDet] = importDetails();
Smry = struct(...
    'BDet',[BDet.Value(1); BDet.Value(10); BDet.Value(7); BDet.Value(8);...
    BDet.Value(12); BDet.Value(9); BDet.Value(3); BDet.Value(4);...
    BDet.Value(6); BDet.Value(14)],...
    'ADet',[ADet.Value(1); ADet.Value(10); ADet.Value(7); ADet.Value(8);...
    ADet.Value(12); ADet.Value(9); ADet.Value(3); ADet.Value(4);...
    ADet.Value(6); ADet.Value(14)],...
    'SDet',[SDet.Value(1); SDet.Value(10); SDet.Value(7); SDet.Value(8);...
    SDet.Value(12); SDet.Value(9); SDet.Value(3); SDet.Value(4);...
    SDet.Value(6); SDet.Value(14)]...
    );

%Initial values for Reference Machine Table
set(handles.uitable1, 'data', ...
    {Smry.BDet(1) 'MW';Smry.BDet(2) 'kNm';Smry.BDet(3) 'RPM';...
    Smry.BDet(4) 'mm';Smry.BDet(5) 'mm';Smry.BDet(6) 'mm';...
    Smry.BDet(7) 'mm';Smry.BDet(8) 'mm';Smry.BDet(9) 'ton'...
    ;Smry.BDet(10) 'kN/m^2'})


%Initial State of the Art Map
axes(handles.map);
imshow('Zhang_B.png');
hold on

% Choose default command line output for Generator_Scaling
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

function plotTd(handles)
axes(handles.map);
imshow('Zhang_B.png');
x=str2double(get(handles.edit_Td,'string'));
y=str2double(get(handles.edit_Pd,'string'));
k_sx=557/2;
k_sy=-573/2;
axes(handles.map)
plot((log10(x)*k_sx+80),(log10(y)*k_sy+1753/2),'ro')



% --- Outputs from this function are returned to the command line.
function varargout = Generator_Scaling_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in push_scale.
function push_scale_Callback(hObject, eventdata, handles)
% hObject    handle to push_scale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global radio
P_scaled = str2double(get(handles.P_scaled,'String'));
for i=1:length(radio)
    if get(radio(i),'Value')==1
        ref = i;
    end
end

%Retrive scaled values
[Tension_tan_new, m_tot_new, m_act_new, m_sup_new, D_ag_new,...
    l_lam_new, cost_Cu, cost_Feys, cost_Feyr, cost_PM, cost_str]=...
    scaling(P_scaled, ref, handles);

%set number of significant numbers of output
precision=3;
%Set value of scaled parameters
set(handles.tens_scaled,'String',num2str(Tension_tan_new,precision));
set(handles.m_scaled,'String',num2str(m_tot_new,precision));
set(handles.m_act_scaled,'String',num2str(m_act_new,precision));
set(handles.m_sup_scaled,'String',num2str(m_sup_new,precision));
set(handles.l_active_scaled,'String',num2str(l_lam_new,precision));
set(handles.D_ag_scaled,'String',num2str(D_ag_new,precision));

set(handles.cost_cu_scaled,'String',num2str(cost_Cu,precision));
set(handles.cost_feys_scaled,'String',num2str(cost_Feys,precision));
set(handles.cost_feyr_scaled,'String',num2str(cost_Feyr,precision));
set(handles.cost_PM_scaled,'String',num2str(cost_PM,precision));
set(handles.cost_str,'String',num2str(cost_str,precision));

% --- Executes on button press in push_ref.
function push_ref_Callback(hObject, eventdata, handles)
% hObject    handle to push_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Smry radio

for i=1:length(radio)                                                            
if get(radio(i),'Value')==1
    if i == 1
        axes(handles.map);
        imshow('Zhang_B.png'); 
        set(handles.uitable1, 'data',...
            {Smry.BDet(1) 'MW';Smry.BDet(2) 'kNm';Smry.BDet(3) 'RPM';...
            Smry.BDet(4) 'mm';Smry.BDet(5) 'mm';Smry.BDet(6) 'mm';...
            Smry.BDet(7) 'mm';Smry.BDet(8) 'mm';Smry.BDet(9) 'ton';...
            Smry.BDet(10) 'kN/m^2'})
    elseif i == 2
        imshow('Zhang_B.png'); 
        set(handles.uitable1, 'data',...
            {Smry.ADet(1) 'MW';Smry.ADet(2) 'kNm';Smry.ADet(3) 'RPM';...
            Smry.ADet(4) 'mm';Smry.ADet(5) 'mm';Smry.ADet(6) 'mm';...
            Smry.ADet(7) 'mm';Smry.ADet(8) 'mm';Smry.ADet(9) 'ton';...
            Smry.ADet(10) 'kN/m^2'})
    elseif i == 3
        imshow('Zhang_B.png');  
        set(handles.uitable1, 'data',...
            {Smry.SDet(1) 'MW';Smry.SDet(2) 'kNm';Smry.SDet(3) 'RPM';...
            Smry.SDet(4) 'mm';Smry.SDet(5) 'mm';Smry.SDet(6) 'mm';...
            Smry.SDet(7) 'mm';Smry.SDet(8) 'mm';Smry.SDet(9) 'ton';...
            Smry.SDet(10) 'kN/m^2'})
    end
end
end  



function P_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to P_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of P_scaled as text
%        str2double(get(hObject,'String')) returns contents of P_scaled as a double


% --- Executes during object creation, after setting all properties.
function P_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to P_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function n_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to n_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_scaled as text
%        str2double(get(hObject,'String')) returns contents of n_scaled as a double


% --- Executes during object creation, after setting all properties.
function n_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function m_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to m_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of m_scaled as text
%        str2double(get(hObject,'String')) returns contents of m_scaled as a double


% --- Executes during object creation, after setting all properties.
function m_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function m_act_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to m_act_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of m_act_scaled as text
%        str2double(get(hObject,'String')) returns contents of m_act_scaled as a double


% --- Executes during object creation, after setting all properties.
function m_act_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_act_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function m_sup_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to m_sup_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of m_sup_scaled as text
%        str2double(get(hObject,'String')) returns contents of m_sup_scaled as a double


% --- Executes during object creation, after setting all properties.
function m_sup_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_sup_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tens_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to tens_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tens_scaled as text
%        str2double(get(hObject,'String')) returns contents of tens_scaled as a double


% --- Executes during object creation, after setting all properties.
function tens_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tens_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function l_lam_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to l_active_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of l_active_scaled as text
%        str2double(get(hObject,'String')) returns contents of l_active_scaled as a double


% --- Executes during object creation, after setting all properties.
function l_active_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to l_active_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function D_ag_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to D_ag_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of D_ag_scaled as text
%        str2double(get(hObject,'String')) returns contents of D_ag_scaled as a double


% --- Executes during object creation, after setting all properties.
function D_ag_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to D_ag_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function cost_feys_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to cost_feys_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cost_feys_scaled as text
%        str2double(get(hObject,'String')) returns contents of cost_feys_scaled as a double


% --- Executes during object creation, after setting all properties.
function cost_feys_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cost_feys_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cost_cu_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to cost_cu_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cost_cu_scaled as text
%        str2double(get(hObject,'String')) returns contents of cost_cu_scaled as a double


% --- Executes during object creation, after setting all properties.
function cost_cu_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cost_cu_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cost_PM_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to cost_PM_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cost_PM_scaled as text
%        str2double(get(hObject,'String')) returns contents of cost_PM_scaled as a double


% --- Executes during object creation, after setting all properties.
function cost_PM_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cost_PM_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cost_feyr_scaled_Callback(hObject, eventdata, handles)
% hObject    handle to cost_feyr_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cost_feyr_scaled as text
%        str2double(get(hObject,'String')) returns contents of cost_feyr_scaled as a double


% --- Executes during object creation, after setting all properties.
function cost_feyr_scaled_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cost_feyr_scaled (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_plot.
function push_plot_Callback(hObject, eventdata, handles)
[P_loss,V,P_loss_V]=losses();
surf(handles.axes1,P_loss)


% hObject    handle to push_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in push_mass.
function push_mass_Callback(hObject, eventdata, handles)
% hObject    handle to push_mass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Mass_Scaling


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Eta_Scaling


% --- Executes on button press in push_lD.
function push_lD_Callback(hObject, eventdata, handles)
% hObject    handle to push_lD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
lD_Scaling



function edit_Pd_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Pd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Pd as text
%        str2double(get(hObject,'String')) returns contents of edit_Pd as a double


% --- Executes during object creation, after setting all properties.
function edit_Pd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Pd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_Td_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Td (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Td as text
%        str2double(get(hObject,'String')) returns contents of edit_Td as a double


% --- Executes during object creation, after setting all properties.
function edit_Td_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Td (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_plotTd.
function push_plotTd_Callback(hObject, eventdata, handles)
% hObject    handle to push_plotTd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.map)

plotTd(handles)
