function varargout = Mass_Scaling(varargin)
% MASS_SCALING MATLAB code for Mass_Scaling.fig
%      MASS_SCALING, by itself, creates a new MASS_SCALING or raises the existing
%      singleton*.
%
%      H = MASS_SCALING returns the handle to a new MASS_SCALING or the handle to
%      the existing singleton*.
%
%      MASS_SCALING('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MASS_SCALING.M with the given input arguments.
%
%      MASS_SCALING('Property','Value',...) creates a new MASS_SCALING or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Mass_Scaling_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Mass_Scaling_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Mass_Scaling

% Last Modified by GUIDE v2.5 22-Jun-2015 14:55:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Mass_Scaling_OpeningFcn, ...
                   'gui_OutputFcn',  @Mass_Scaling_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Mass_Scaling is made visible.
function Mass_Scaling_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Mass_Scaling (see VARARGIN)



massPlot_vP(handles)


% Choose default command line output for Mass_Scaling
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Mass_Scaling wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Mass_Scaling_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function massPlot_vP(handles)
m_1=str2double(get(handles.edit_m1, 'string'));
P_1=str2double(get(handles.edit_P1, 'string'));
P_2=str2double(get(handles.edit_P2, 'string'));
[m_em2,m_cy2,m_beam2,m_tot2]=mass_scale_PS(m_1,P_1);
P=1:0.5:10;
axes(handles.axes_mass)
plot(P,m_cy2,P,m_beam2,P,m_em2,P,m_tot2)
xlabel('P_{out} [MW]')
ylabel('Mass [Ton]')
hold on
line([P_2,P_2],[0,m_tot2(find(P>P_2,1,'first')-1)])
legend('m_{cy}','m_{beam}','m_{em}','m_{tot}')
hold off

function massPlot_vAR(handles)
m_1=str2double(get(handles.edit_m1, 'string'));
k_AR1=str2double(get(handles.edit_AR1, 'string'));
k_AR2=str2double(get(handles.edit_AR2, 'string'));
k_AR=0.05:0.95/20:1;
[m_em2,m_cy2,m_beam2,m_tot2]=mass_scale_vAR_PS(m_1,k_AR1);

axes(handles.axes_mass)
plot(k_AR,m_cy2,k_AR,m_beam2,k_AR,m_em2,k_AR,m_tot2)
legend('m_{cy}','m_{beam}','m_{em}','m_{tot}')
xlabel('k_{AR} [-]')
ylabel('Mass [Ton]')

hold on
line([k_AR2,k_AR2],[0,m_tot2(find(k_AR>k_AR2,1,'first')-1)])
hold off


function edit_m1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m1 as text
%        str2double(get(hObject,'String')) returns contents of edit_m1 as a double


% --- Executes during object creation, after setting all properties.
function edit_m1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m2 as text
%        str2double(get(hObject,'String')) returns contents of edit_m2 as a double


% --- Executes during object creation, after setting all properties.
function edit_m2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_P1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_P1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_P1 as text
%        str2double(get(hObject,'String')) returns contents of edit_P1 as a double


% --- Executes during object creation, after setting all properties.
function edit_P1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_P1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_P2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_P2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_P2 as text
%        str2double(get(hObject,'String')) returns contents of edit_P2 as a double


% --- Executes during object creation, after setting all properties.
function edit_P2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_P2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_AR1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AR1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_AR1 as text
%        str2double(get(hObject,'String')) returns contents of edit_AR1 as a double


% --- Executes during object creation, after setting all properties.
function edit_AR1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AR1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_AR2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AR2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_AR2 as text
%        str2double(get(hObject,'String')) returns contents of edit_AR2 as a double


% --- Executes during object creation, after setting all properties.
function edit_AR2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AR2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_l1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_l1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_l1 as text
%        str2double(get(hObject,'String')) returns contents of edit_l1 as a double


% --- Executes during object creation, after setting all properties.
function edit_l1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_l1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_D1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_D1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_D1 as text
%        str2double(get(hObject,'String')) returns contents of edit_D1 as a double


% --- Executes during object creation, after setting all properties.
function edit_D1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_D1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit45_Callback(hObject, eventdata, handles)
% hObject    handle to edit_l2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_l2 as text
%        str2double(get(hObject,'String')) returns contents of edit_l2 as a double


% --- Executes during object creation, after setting all properties.
function edit_l2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_l2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit46_Callback(hObject, eventdata, handles)
% hObject    handle to edit_D2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_D2 as text
%        str2double(get(hObject,'String')) returns contents of edit_D2 as a double


% --- Executes during object creation, after setting all properties.
function edit_D2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_D2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m_em_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m_em (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m_em as text
%        str2double(get(hObject,'String')) returns contents of edit_m_em as a double


% --- Executes during object creation, after setting all properties.
function edit_m_em_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m_em (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m_beam_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m_beam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m_beam as text
%        str2double(get(hObject,'String')) returns contents of edit_m_beam as a double


% --- Executes during object creation, after setting all properties.
function edit_m_beam_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m_beam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_plot_vAR.
function push_plot_vAR_Callback(hObject, eventdata, handles)
% hObject    handle to push_plot_vAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

massPlot_vAR(handles)

% --- Executes on button press in push_plot_vP.
function push_plot_vP_Callback(hObject, eventdata, handles)
% hObject    handle to push_plot_vP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

massPlot_vP(handles)



function edit_m2_vAR_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m2_vAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m2_vAR as text
%        str2double(get(hObject,'String')) returns contents of edit_m2_vAR as a double


% --- Executes during object creation, after setting all properties.
function edit_m2_vAR_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m2_vAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m_cyl_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m_cyl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m_cyl as text
%        str2double(get(hObject,'String')) returns contents of edit_m_cyl as a double


% --- Executes during object creation, after setting all properties.
function edit_m_cyl_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m_cyl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_l2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_l2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_l2 as text
%        str2double(get(hObject,'String')) returns contents of edit_l2 as a double



function edit_D2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_D2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_D2 as text
%        str2double(get(hObject,'String')) returns contents of edit_D2 as a double


% --- Executes when selected object is changed in uipanel5.
function uipanel5_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel5 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if get(handles.radio_cAR,'value');
    set(handles.edit_P2,'enable','on')
    set(handles.edit_m2,'enable','inactive')
    set(handles.push_calc_cAR,'enable','on')
    set(handles.edit_AR2,'enable','off')
    set(handles.edit_m2_vAR,'enable','off')
    set(handles.push_calc_vAR,'enable','off')
else
    set(handles.edit_P2,'enable','off')
    set(handles.edit_m2,'enable','off')
    set(handles.push_calc_cAR,'enable','off')
    set(handles.edit_AR2,'enable','on')
    set(handles.edit_m2_vAR,'enable','inactive')
    set(handles.push_calc_vAR,'enable','on')
end


% --- Executes on button press in push_calc_cAR.
function push_calc_cAR_Callback(hObject, eventdata, handles)
% hObject    handle to push_calc_cAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m_1=str2double(get(handles.edit_m1, 'string'));
P_1=str2double(get(handles.edit_P1, 'string'));
P_2=str2double(get(handles.edit_P2, 'string'));
l_1=str2double(get(handles.edit_l1, 'string'));
D_1=str2double(get(handles.edit_D1, 'string'));
k_AR_1=l_1/D_1;
V_1=pi/4*l_1*D_1^2;
l_2=((4*V_1*P_2*k_AR_1^2)/(pi*P_1))^(1/3);
D_2=((4*V_1*P_2)/(pi*P_1*k_AR_1))^(1/3);
[m_em_2,m_cy_2,m_beam_2,m_tot_2]=mass_scale(m_1,P_1,P_2);

set(handles.edit_m2, 'string',num2str(m_tot_2))
set(handles.edit_m_cyl, 'string',num2str(m_cy_2))
set(handles.edit_m_beam, 'string',num2str(m_beam_2))
set(handles.edit_m_em, 'string',num2str(m_em_2))
set(handles.edit_l2, 'string',num2str(l_2))
set(handles.edit_D2, 'string',num2str(D_2))


% --- Executes on button press in push_calc_vAR.
function push_calc_vAR_Callback(hObject, eventdata, handles)
% hObject    handle to push_calc_vAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
m_1=str2double(get(handles.edit_m1, 'string'));
k_AR1=str2double(get(handles.edit_AR1, 'string'));
k_AR2=str2double(get(handles.edit_AR2, 'string'));
[m_cy_2,m_beam_2,m_em_2,m_tot2]=mass_scale_vAR(m_1,k_AR1,k_AR2);
set(handles.edit_l2, 'string','-')
set(handles.edit_D2, 'string','-')
set(handles.edit_m2_vAR, 'string',num2str(m_tot2))
set(handles.edit_m_cyl, 'string',num2str(m_cy_2))
set(handles.edit_m_beam, 'string',num2str(m_beam_2))
set(handles.edit_m_em, 'string',num2str(m_em_2))
