function [eta_2,P_loss_tot_2,l,D_ag]=...
   lossesPS_ring(eta_1,P_out_1,l_1,D_ag_1)
%TEST VALUES
% eta_1=0.955;
% P_out_1=2e6;
% % %V_r_1=19.6;
% l_1=0.6;
% D_ag_1=2;

%GET LOSSES
[P_loss_tot_1,P_loss_ring]=loss_ring(eta_1,P_out_1,l_1,D_ag_1);

%Set length and diameter range
[l,D_ag]=ranges(l_1,D_ag_1);

%Calculate Rotor Volume and Air Gap Surfce Area
V_r_1=pi/4*D_ag_1^2*l_1;
V_r_2=pi/4.*l'*D_ag.^2;
A_ag_2=pi*l'*D_ag;

%Scale loss
P_loss_tot_2=P_loss_ring.*A_ag_2;
P_out_2=V_r_2./V_r_1.*P_out_1;

%Establish Efficiency
eta_2=zeros(length(l),length(D_ag));
for i=1:length(l)
    for j=1:length(D_ag)
    eta_2(i,j)= P_out_2(i,j)/(P_out_2(i,j)+P_loss_tot_2(i,j));
    end
end


%PLOTTING EFFICIENCY
% surf(D_ag,l,eta_2)
% xlabel('Air Gap Diameter, D_{ag}','fontsize',16)
% ylabel('Active Length, l','fontsize',16)
% zlabel('{\eta}','fontsize',16)


%PLOTTING LOSSES
% figure
% surf(D_ag,l,P_loss_tot_2)
% xlabel('Air Gap Diameter, D_{ag}','fontsize',16)
% ylabel('Active Length, l','fontsize',16)
% zlabel('{P_{loss,tot}}','fontsize',16)
% grid on
% figure
% surf(D_ag,l,P_out_2)
% xlabel('Air Gap Diameter, D_{ag}','fontsize',16)
% ylabel('Active Length, l','fontsize',16)
% zlabel('{P_{out}}','fontsize',16)
